org.apache.commons.math3.distribution

## Class PascalDistribution

- java.lang.Object
- - org.apache.commons.math3.distribution.AbstractIntegerDistribution
  - - org.apache.commons.math3.distribution.PascalDistribution

- All Implemented Interfaces:
    Serializable, IntegerDistribution

      public class PascalDistribution
      extends AbstractIntegerDistribution

  Implementation of the Pascal distribution. The Pascal distribution is a special case of the Negative Binomial distribution where the number of successes parameter is an integer.

  There are various ways to express the probability mass and distribution functions for the Pascal distribution. The present implementation represents the distribution of the number of failures before `r` successes occur. This is the convention adopted in e.g. MathWorld, but not in Wikipedia.

  For a random variable `X` whose values are distributed according to this distribution, the probability mass function is given by
  `P(X = k) = C(k + r - 1, r - 1) * p^r * (1 - p)^k,`
  where `r` is the number of successes, `p` is the probability of success, and `X` is the total number of failures. `C(n, k)` is the binomial coefficient (`n` choose `k`). The mean and variance of `X` are
  `E(X) = (1 - p) * r / p, var(X) = (1 - p) * r / p^2.`
  Finally, the cumulative distribution function is given by
  `P(X <= k) = I(p, r, k + 1)`, where I is the regularized incomplete Beta function.

  Since:
    1.2 (changed to concrete class in 3.0)
  Version:
    $Id: PascalDistribution.java 1244107 2012-02-14 16:17:55Z erans $
  See Also:
    Negative binomial distribution (Wikipedia), Negative binomial distribution (MathWorld), Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.apache.commons.math3.distribution.AbstractIntegerDistribution

      `randomData`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PascalDistribution(int r, double p)` Create a Pascal distribution with the given number of successes and probability of success.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `double` | `cumulativeProbability(int x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
    `int` | `getNumberOfSuccesses()` Access the number of successes for this distribution.
    `double` | `getNumericalMean()` Use this method to get the numerical value of the mean of this distribution.
    `double` | `getNumericalVariance()` Use this method to get the numerical value of the variance of this distribution.
    `double` | `getProbabilityOfSuccess()` Access the probability of success for this distribution.
    `int` | `getSupportLowerBound()` Access the lower bound of the support.
    `int` | `getSupportUpperBound()` Access the upper bound of the support.
    `boolean` | `isSupportConnected()` Use this method to get information about whether the support is connected, i.e.
    `double` | `probability(int x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`.

    - ### Methods inherited from class org.apache.commons.math3.distribution.AbstractIntegerDistribution

      `cumulativeProbability, inverseCumulativeProbability, reseedRandomGenerator, sample, sample, solveInverseCumulativeProbability`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PascalDistribution

          public PascalDistribution(int r,
                            double p)
                             throws NotStrictlyPositiveException,
                                    OutOfRangeException

      Create a Pascal distribution with the given number of successes and probability of success.
      Parameters:
        `r` - Number of successes.
        `p` - Probability of success.
      Throws:
        `NotStrictlyPositiveException` - if the number of successes is not positive
        `OutOfRangeException` - if the probability of success is not in the range [0, 1]

  - ### Method Detail

    - #### getNumberOfSuccesses

          public int getNumberOfSuccesses()

      Access the number of successes for this distribution.
      Returns:
        the number of successes.

    - #### getProbabilityOfSuccess

          public double getProbabilityOfSuccess()

      Access the probability of success for this distribution.
      Returns:
        the probability of success.

    - #### probability

          public double probability(int x)

      For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`. In other words, this method represents the probability mass function (PMF) for the distribution.
      Parameters:
        `x` - the point at which the PMF is evaluated
      Returns:
        the value of the probability mass function at `x`

    - #### cumulativeProbability

          public double cumulativeProbability(int x)

      For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution.
      Parameters:
        `x` - the point at which the CDF is evaluated
      Returns:
        the probability that a random variable with this distribution takes a value less than or equal to `x`

    - #### getNumericalMean

          public double getNumericalMean()

      Use this method to get the numerical value of the mean of this distribution. For number of successes `r` and probability of success `p`, the mean is `r * (1 - p) / p`.
      Returns:
        the mean or `Double.NaN` if it is not defined

    - #### getNumericalVariance

          public double getNumericalVariance()

      Use this method to get the numerical value of the variance of this distribution. For number of successes `r` and probability of success `p`, the variance is `r * (1 - p) / p^2`.
      Returns:
        the variance (possibly `Double.POSITIVE_INFINITY` or `Double.NaN` if it is not defined)

    - #### getSupportLowerBound

          public int getSupportLowerBound()

      Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

      `inf {x in Z | P(X <= x) > 0}`.

      The lower bound of the support is always 0 no matter the parameters.
      Returns:
        lower bound of the support (always 0)

    - #### getSupportUpperBound

          public int getSupportUpperBound()

      Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

      `inf {x in R | P(X <= x) = 1}`.

      The upper bound of the support is always positive infinity no matter the parameters. Positive infinity is symbolized by `Integer.MAX_VALUE`.
      Returns:
        upper bound of the support (always `Integer.MAX_VALUE` for positive infinity)

    - #### isSupportConnected

          public boolean isSupportConnected()

      Use this method to get information about whether the support is connected, i.e. whether all integers between the lower and upper bound of the support are included in the support. The support of this distribution is connected.
      Returns:
        `true`

Copyright © 2003-2012 The Apache Software Foundation. All Rights Reserved.